using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CallCenterApi.BLL
{
    /// <summary>
	/// T_Call_OutTask
	/// </summary>
	public partial class T_Call_OutTask
    {
        private readonly CallCenterApi.DAL.T_Call_OutTask dal = new CallCenterApi.DAL.T_Call_OutTask();
        public T_Call_OutTask()
        { }
        #region  BasicMethod

        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(CallCenterApi.Model.T_Call_OutTask model)
        {
            return dal.Add(model);
        }

        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(CallCenterApi.Model.T_Call_OutTask model)
        {
            return dal.Update(model);
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_TaskID)
        {

            return dal.Delete(F_TaskID);
        }
        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool DeleteList(string F_TaskIDlist)
        {
            return dal.DeleteList(F_TaskIDlist);
        }

        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Call_OutTask GetModel(int F_TaskID)
        {

            return dal.GetModel(F_TaskID);
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            return dal.GetList(strWhere);
        }
        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            return dal.GetList(Top, strWhere, filedOrder);
        }
        /// <summary>
        /// 获得数据列表
        /// </summary>
        public List<CallCenterApi.Model.T_Call_OutTask> GetModelList(string strWhere)
        {
            DataSet ds = dal.GetList(strWhere);
            return DataTableToList(ds.Tables[0]);
        }
        /// <summary>
        /// 获得数据列表
        /// </summary>
        public List<CallCenterApi.Model.T_Call_OutTask> DataTableToList(DataTable dt)
        {
            List<CallCenterApi.Model.T_Call_OutTask> modelList = new List<CallCenterApi.Model.T_Call_OutTask>();
            int rowsCount = dt.Rows.Count;
            if (rowsCount > 0)
            {
                CallCenterApi.Model.T_Call_OutTask model;
                for (int n = 0; n < rowsCount; n++)
                {
                    model = dal.DataRowToModel(dt.Rows[n]);
                    if (model != null)
                    {
                        modelList.Add(model);
                    }
                }
            }
            return modelList;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetAllList()
        {
            return GetList("");
        }

        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            return dal.GetRecordCount(strWhere);
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            return dal.GetListByPage(strWhere, orderby, startIndex, endIndex);
        }

        #endregion  BasicMethod
        #region  ExtensionMethod
        /// <summary>
        /// 更新分配状态
        /// </summary>
        public bool UpdateAllot(int taskid, int isallot, string alUCode, DateTime altime)
        {
            return dal.UpdateAllot(taskid, isallot, alUCode, altime);
        }

        /// <summary>
        /// 更新启动状态
        /// </summary>
        public bool UpdateStart(int taskid, int isstart, DateTime stime, DateTime etime)
        {
            return dal.UpdateStart(taskid, isstart, stime, etime);
        }
        #endregion  ExtensionMethod
    }
}
